Package com.smartgwt.client.widgets.drawing

# Class DrawOval

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.drawing.DrawItem
com.smartgwt.client.widgets.drawing.DrawOval

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDrawEndHandlers`, `HasDrawStartHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseUpHandlers`, `HasMovedHandlers`, `HasResizedHandlers`, `HasShowContextMenuHandlers`

public class DrawOval extends DrawItem
DrawItem subclass to render oval shapes, including circles.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DrawOval()`
  `DrawOval(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, DrawItem defaults)`
  Changes the defaults for DrawItem AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `protected JavaScriptObject`
  `create()`
  `Point`
  `getCenter()`
  Get the center of the oval.
  `Point`
  `getCenterPoint()`
  Center point of the oval.
  `int`
  `getHeight()`
  Height in pixels relative to the `local coordinate system`.
  `double`
  `getHeightAsDouble()`
  Height in pixels relative to the `local coordinate system`.
  `int`
  `getLeft()`
  Left coordinate in pixels relative to the `local coordinate system`.
  `double`
  `getLeftAsDouble()`
  Left coordinate in pixels relative to the `local coordinate system`.
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `static DrawOval`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `int`
  `getRadiusX()`
  Returns the horizontal radius of the DrawOval.
  `int`
  `getRadiusY()`
  Returns the vertical radius of the DrawOval.
  `TitleRotationMode`
  `getTitleRotationMode()`
  The mode in which the `titleLabel` (if shown) is rotated with this draw item.
  `int`
  `getTop()`
  Top coordinate in pixels relative to the `local coordinate system`.
  `double`
  `getTopAsDouble()`
  Top coordinate in pixels relative to the `local coordinate system`.
  `int`
  `getWidth()`
  Width in pixels relative to the `local coordinate system`.
  `double`
  `getWidthAsDouble()`
  Width in pixels relative to the `local coordinate system`.
  `void`
  `moveBy(int dX, int dY)`
  Move the drawOval by the specified delta
  `void`
  `moveTo(Integer left, Integer top)`
  Move the drawOval to the specified left/top position.
  `void`
  `resizeBy(int dX, int dY)`
  Resize by the specified delta.
  `void`
  `resizeTo(Integer width, Integer height)`
  Resize to the specified size.
  `DrawOval`
  `setCenterPoint(Point centerPoint)`
  Center point of the oval.
  `static void`
  `setDefaultProperties(DrawOval drawOvalProperties)`
  Class level method to set the default properties of this class.
  `DrawOval`
  `setHeight(int height)`
  Height in pixels relative to the `local coordinate system`.
  `DrawOval`
  `setLeft(int left)`
  Left coordinate in pixels relative to the `local coordinate system`.
  `LogicalStructureObject`
  `setLogicalStructure(DrawOvalLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `void`
  `setOval(int cx, int cy, int rx, int ry)`
  Resize and reposition the drawOval by setting its radius, and centerPoint.
  `void`
  `setRadii(int rx, int ry)`
  Resize the drawOval by setting its horizontal and vertical radius, and retaining its current center point.
  `DrawOval`
  `setRadius(Integer radius)`
  Radius of the oval.
  `void`
  `setRect(Integer left, Integer top, Integer width, Integer height)`
  Move and resize the drawOval to match the specified coordinates and size.
  `DrawOval`
  `setTitleRotationMode(TitleRotationMode titleRotationMode)`
  The mode in which the `titleLabel` (if shown) is rotated with this draw item.
  `DrawOval`
  `setTop(int top)`
  Top coordinate in pixels relative to the `local coordinate system`.
  `DrawOval`
  `setWidth(int width)`
  Width in pixels relative to the `local coordinate system`.

  ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

  `addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDrawEndHandler, addDrawStartHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, bringToFront, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getBoundingBox, getBoundingBoxAsDouble, getById, getByJSObject, getCanDrag, getCanHover, getCanvasAutoChild, getContextMenu, getCornerResizeKnob, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawItemAutoChild, getDrawPane, getDrawPaneAsString, getEditProxyConstructor, getEndArrow, getEndKnob, getEventOpaque, getEventPassThrough, getFillColor, getFillGradient, getFillGradientAsString, getFillOpacity, getFormItemAutoChild, getHoverDelay, getHoverHTML, getKeepInParentRect, getKnobs, getLineCap, getLineColor, getLineOpacity, getLinePattern, getLineWidth, getMoveKnob, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPaletteDefaults, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRef, getResizeBoundingBox, getResizeBoundingBoxAsDouble, getResizeKnobPoints, getResizeOutline, getResizeViaLocalTransformOnly, getRotateKnob, getRotation, getRotationAsDouble, getScale, getShadow, getShowHover, getShowResizeOutline, getShowTitleLabelBackground, getSideResizeKnob, getStartArrow, getStartKnob, getSvgString, getTitle, getTitleAutoFit, getTitleAutoFitMargin, getTitleAutoFitRotationMode, getTitleLabel, getTitleLabelBackground, getTitleLabelPadding, getTranslate, getUnderlyingGWTCanvas, getUseSimpleTransform, getXShearFactor, getYShearFactor, getZIndex, hide, hideAllKnobs, hideKnobs, hideKnobs, hover, isInBounds, isPointInPath, rotateBy, rotateTo, scaleBy, scaleTo, sendToBack, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setCanDrag, setCanHover, setCenterPoint, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setDrawPane, setEditProxyConstructor, setEndArrow, setEventOpaque, setEventPassThrough, setFillColor, setFillGradient, setFillGradient, setFillOpacity, setHoverDelay, setKeepInParentRect, setKeepInParentRect, setKnobs, setLineCap, setLineColor, setLineOpacity, setLinePattern, setLineWidth, setLogicalStructure, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setPropertyValue, setProportionalResizeModifiers, setProportionalResizing, setResizeKnobPoints, setResizeViaLocalTransformOnly, setRotation, setRotation, setScale, setShadow, setShapeData, setShowHover, setShowResizeOutline, setShowTitleLabelBackground, setStartArrow, setTitle, setTitleAutoFit, setTitleAutoFitMargin, setTitleAutoFitRotationMode, setTitleLabelPadding, setTranslate, setUseSimpleTransform, setXShearFactor, setYShearFactor, setZIndex, show, showAllKnobs, showKnobs, showKnobs, supportsEndArrow, supportsStartArrow`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, equals, error, errorIfNotCreated, getAttribute, getAttributeAsDateArray, getAttributeAsFloatArray, getAttributeAsIntArray, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAutoDraw, getClassName, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, onInit, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setHtmlElement, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onAttach, onBrowserEvent, onDetach, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, addStyleName, ensureDebugId, ensureDebugId, ensureDebugId, getAbsoluteLeft, getAbsoluteTop, getElement, getOffsetHeight, getOffsetWidth, getStyleElement, getStyleName, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setElement, setHeight, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, setVisible, setWidth, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### DrawOval

    public DrawOval()

  - ### DrawOval

    public DrawOval(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static DrawOval getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, DrawItem defaults)
    Changes the defaults for DrawItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - DrawItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `DrawItem`

  - ### setCenterPoint

    public DrawOval setCenterPoint(Point centerPoint)
    Center point of the oval. If unset, derived from left/top/width/height.
    If this method is called after the component has been drawn/initialized: Change the center point for this oval.
    Parameters:
      `centerPoint` - left coordinate (in the global coordinate system). Default value is null
    Returns:
      `DrawOval` instance, for chaining setter calls

  - ### getCenterPoint

    public Point getCenterPoint()
    Center point of the oval. If unset, derived from left/top/width/height.
    Returns:
      Current centerPoint value. Default value is null

  - ### setHeight

    public DrawOval setHeight(int height)
    Height in pixels relative to the `local coordinate system`.
    If this method is called after the component has been drawn/initialized: Set the height of the drawOval
    Parameters:
      `height` - new height. Default value is 100
    Returns:
      `DrawOval` instance, for chaining setter calls

  - ### getHeight

    public int getHeight()
    Height in pixels relative to the `local coordinate system`.
    Returns:
      Current height value. Default value is 100

  - ### getHeightAsDouble

    public double getHeightAsDouble()
    Height in pixels relative to the `local coordinate system`.
    Returns:
      Current height value. Default value is 100

  - ### setLeft

    public DrawOval setLeft(int left)
    Left coordinate in pixels relative to the `local coordinate system`.
    If this method is called after the component has been drawn/initialized: Set the left coordinate of the drawOval
    Parameters:
      `left` - new left coordinate. Default value is 0
    Returns:
      `DrawOval` instance, for chaining setter calls

  - ### getLeft

    public int getLeft()
    Left coordinate in pixels relative to the `local coordinate system`.
    Returns:
      Current left value. Default value is 0

  - ### getLeftAsDouble

    public double getLeftAsDouble()
    Left coordinate in pixels relative to the `local coordinate system`.
    Returns:
      Current left value. Default value is 0

  - ### setRadius

    public DrawOval setRadius(Integer radius)
    Radius of the oval. Since this is used to initialize the `horizontal` and `vertical` radii, then the oval is a circle.

    If unset, the horizontal and vertical radii are set to half the `width` and `height`.
    If this method is called after the component has been drawn/initialized: Resize the drawOval by setting its radius, and retaining its current center point. Equivalent to `setRadii(radius, radius)`.

    Parameters:
      `radius` - new radius. This will be applied on both axes, meaning calling this method will always result in the DrawOval being a circle. Default value is null
    Returns:
      `DrawOval` instance, for chaining setter calls
    See Also:
      - `getRadiusX()`
      - `getRadiusY()`

  - ### setTitleRotationMode

    public DrawOval setTitleRotationMode(TitleRotationMode titleRotationMode) throws IllegalStateException
    The mode in which the `titleLabel` (if shown) is rotated with this draw item.

    Note : This is an advanced setting

    Overrides:
      `setTitleRotationMode` in class `DrawItem`
    Parameters:
      `titleRotationMode` - New titleRotationMode value. Default value is "withItemAlwaysUp"
    Returns:
      `DrawOval` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `DrawItem.setTitle(java.lang.String)`

  - ### getTitleRotationMode

    public TitleRotationMode getTitleRotationMode()
    The mode in which the `titleLabel` (if shown) is rotated with this draw item.
    Overrides:
      `getTitleRotationMode` in class `DrawItem`
    Returns:
      Current titleRotationMode value. Default value is "withItemAlwaysUp"
    See Also:
      - `DrawItem.getTitle()`

  - ### setTop

    public DrawOval setTop(int top)
    Top coordinate in pixels relative to the `local coordinate system`.
    If this method is called after the component has been drawn/initialized: Set the top coordinate of the drawOval
    Parameters:
      `top` - new top coordinate. Default value is 0
    Returns:
      `DrawOval` instance, for chaining setter calls

  - ### getTop

    public int getTop()
    Top coordinate in pixels relative to the `local coordinate system`.
    Returns:
      Current top value. Default value is 0

  - ### getTopAsDouble

    public double getTopAsDouble()
    Top coordinate in pixels relative to the `local coordinate system`.
    Returns:
      Current top value. Default value is 0

  - ### setWidth

    public DrawOval setWidth(int width)
    Width in pixels relative to the `local coordinate system`.
    If this method is called after the component has been drawn/initialized: Set the width of the drawOval
    Parameters:
      `width` - new width. Default value is 100
    Returns:
      `DrawOval` instance, for chaining setter calls

  - ### getWidth

    public int getWidth()
    Width in pixels relative to the `local coordinate system`.
    Returns:
      Current width value. Default value is 100

  - ### getWidthAsDouble

    public double getWidthAsDouble()
    Width in pixels relative to the `local coordinate system`.
    Returns:
      Current width value. Default value is 100

  - ### getCenter

    public Point getCenter()
    Get the center of the oval.
    Overrides:
      `getCenter` in class `DrawItem`
    Returns:
      the center point

  - ### getRadiusX

    public int getRadiusX()
    Returns the horizontal radius of the DrawOval.
    Returns:
      the horizontal radius.
    See Also:
      - `setRadii(int, int)`

  - ### getRadiusY

    public int getRadiusY()
    Returns the vertical radius of the DrawOval.
    Returns:
      the vertical radius.
    See Also:
      - `setRadii(int, int)`

  - ### moveBy

    public void moveBy(int dX, int dY)
    Move the drawOval by the specified delta
    Overrides:
      `moveBy` in class `DrawItem`
    Parameters:
      `dX` - number of pixels to move horizontally
      `dY` - number of pixels to move vertically

  - ### moveTo

    public void moveTo(Integer left, Integer top)
    Move the drawOval to the specified left/top position. You may also call `setCenterPoint()` to reposition the oval around a new center position.
    Overrides:
      `moveTo` in class `DrawItem`
    Parameters:
      `left` - new left coordinate
      `top` - new top coordinate

  - ### resizeBy

    public void resizeBy(int dX, int dY)
    Resize by the specified delta. Note that the resize will occur from the current top/left coordinates, meaning the center positon of the oval may change. You may also use `setRadii()` to change the radius in either direction without modifying the centerpoint.
    Overrides:
      `resizeBy` in class `DrawItem`
    Parameters:
      `dX` - number of pixels to resize by horizontally
      `dY` - number of pixels to resize by vertically

  - ### resizeTo

    public void resizeTo(Integer width, Integer height)
    Resize to the specified size. Note that the resize will occur from the current top/left coordinates, meaning the center positon of the oval may change. You may also use `setRadii()` to change the radius in either direction without modifying the centerpoint.
    Overrides:
      `resizeTo` in class `DrawItem`
    Parameters:
      `width` - new width
      `height` - new height

  - ### setOval

    public void setOval(int cx, int cy, int rx, int ry)
    Resize and reposition the drawOval by setting its radius, and centerPoint.
    Parameters:
      `cx` - new horizontal center point coordinate
      `cy` - new vertical center point coordinate
      `rx` - new horizontal radius
      `ry` - new vertical radius

  - ### setRadii

    public void setRadii(int rx, int ry)
    Resize the drawOval by setting its horizontal and vertical radius, and retaining its current center point.
    Parameters:
      `rx` - new horizontal radius
      `ry` - new vertical radius
    See Also:
      - `getRadiusX()`
      - `getRadiusY()`

  - ### setRect

    public void setRect(Integer left, Integer top, Integer width, Integer height)
    Move and resize the drawOval to match the specified coordinates and size.
    Parameters:
      `left` - new left coordinate
      `top` - new top coordinate
      `width` - new width
      `height` - new height

  - ### setDefaultProperties

    public static void setDefaultProperties(DrawOval drawOvalProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `drawOvalProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(DrawOvalLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `DrawItem`